/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.geometries.gui;

import javax.swing.JFrame;
import javax.swing.WindowConstants;
import org.visnow.jscic.DataContainerSchema;
import org.visnow.vn.geometries.parameters.ColorComponentParams;

/**
 *
 ** @author Krzysztof S. Nowinski, University of Warsaw ICM
 */
public class TextureComponentPanel extends javax.swing.JPanel
{

    private ColorComponentParams params = null;
    private DataContainerSchema schema = null;

    /**
     * Creates new form ColorComponentPanel
     */
    public TextureComponentPanel()
    {
        initComponents();
    }

    public void setParams(ColorComponentParams params)
    {
        this.params = params;
        params.setActive(false);
        dataRangeUI.setComponentValue(params.getColorRange());
        params.setActive(true);
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {

        wrapBox = new javax.swing.JCheckBox();
        dataRangeUI = new org.visnow.vn.lib.gui.ComponentBasedUI.range.ComponentSubrangeUI();

        setBorder(javax.swing.BorderFactory.createTitledBorder(null, "t component", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10))); // NOI18N
        setLayout(new java.awt.BorderLayout());

        wrapBox.setText("wrap");
        wrapBox.setName("wrapBox"); // NOI18N
        wrapBox.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                wrapBoxActionPerformed(evt);
            }
        });
        add(wrapBox, java.awt.BorderLayout.SOUTH);

        dataRangeUI.setName("dataRangeUI"); // NOI18N
        add(dataRangeUI, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents

    private void wrapBoxActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_wrapBoxActionPerformed
    {//GEN-HEADEREND:event_wrapBoxActionPerformed
        if (params == null)
            return;
        params.setWrap(wrapBox.isSelected());
    }//GEN-LAST:event_wrapBoxActionPerformed

    
    public void updateDataValuesFromParams()
    {
        params.setActive(false);
        wrapBox.setSelected(params.isWrap());
        dataRangeUI.updateSubrange();
        params.setActive(true);
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private org.visnow.vn.lib.gui.ComponentBasedUI.range.ComponentSubrangeUI dataRangeUI;
    private javax.swing.JCheckBox wrapBox;
    // End of variables declaration//GEN-END:variables
    public static void main(String[] args)
    {
        JFrame f = new JFrame();
        f.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        final TextureComponentPanel p = new TextureComponentPanel();
        f.add(p);
        f.pack();
        f.setVisible(true);
    }
}
